package com.gyee.alarm.service;


import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.gyee.alarm.init.CacheContext;
import com.gyee.alarm.mapper.auto.ProEconAlarmConfigurationMapper;
import com.gyee.alarm.mapper.auto.ProEconAlarmRuleMapper;
import com.gyee.alarm.model.auto.ProBasicPowerstation;
import com.gyee.alarm.model.auto.ProEconAlarmConfiguration;
import com.gyee.alarm.model.auto.ProEconAlarmType;
import com.gyee.alarm.model.vo.AlarmRuleVo;
import com.gyee.alarm.service.auto.IProEconAlarmConfigurationService;
import com.gyee.alarm.util.SnowflakeGenerator;
import com.gyee.alarm.util.StringUtil;
import com.gyee.alarm.util.StringUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


@Service
public class AlarmConfigurationService {

    @Resource
    private IProEconAlarmConfigurationService proEconAlarmConfigurationService;
    @Resource
    private RuleUpdateEventService ruleUpdateEventService;

    @Resource
    private ProEconAlarmConfigurationMapper proEconAlarmConfigurationMapper;
    private boolean saveAlertrule(ProEconAlarmConfiguration alarmRule) throws Exception {

        boolean result = false;

        if (StringUtils.notEmp(alarmRule)) {
            
            alarmRule.setId(String.valueOf(SnowflakeGenerator.generateId()));
  
            result= proEconAlarmConfigurationService.save(alarmRule);
        }
//        if (result > 0) {
//            int i = eventService.saveEventWarning(alarmRule, oldRule2, userData.getUserName());
        return result;
    }


    public boolean saveAndUpdateAlertrule(ProEconAlarmConfiguration alarmRule) throws Exception {

        boolean result =false;

        if (StringUtils.notEmp(alarmRule)) {

            List<ProEconAlarmConfiguration>  oldRulels = proEconAlarmConfigurationMapper.queryObject(alarmRule.getDescription(),alarmRule.getStationId(),alarmRule.getModelId());
            if (!oldRulels.isEmpty()) {
                ProEconAlarmConfiguration oldRule2=oldRulels.get(0);
                alarmRule.setId(oldRule2.getId());
                result = proEconAlarmConfigurationService.updateById(alarmRule);
                ruleUpdateEventService.saveEventWarning(alarmRule,oldRule2);
            }else
            {
                alarmRule.setId(String.valueOf(SnowflakeGenerator.generateId()));
                ruleUpdateEventService.saveEventWarning(alarmRule,null);
                result = saveAlertrule(alarmRule);
            }

        }else
        {
            alarmRule.setId(String.valueOf(SnowflakeGenerator.generateId()));
            ruleUpdateEventService.saveEventWarning(alarmRule,null);
            result = saveAlertrule(alarmRule);
        }

        return result;
    }

    public boolean deleteAlertrule(String id) {
        return proEconAlarmConfigurationService.removeById(id);
    }


    public IPage<ProEconAlarmConfiguration> pageQueryAll(Page page, String name, String station, String modelId) {


        if(StringUtils.notEmp(name))
        {
            name="%"+name+"%";
        }else
        {
            name=null;
        }
        if(StringUtils.empty(station))
        {
            station=null;
        }
        if(StringUtils.empty(modelId))
        {
            modelId=null;
        }


        IPage<ProEconAlarmConfiguration> alertruleIPage = proEconAlarmConfigurationService.pageQueryAll(page, name, station, modelId);

        return alertruleIPage;
    }


}
